package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.grade.bo.UserPeriodQueryBo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.grade.bo.UserPeriodStatusAddBo;
import com.zhongzheng.modules.grade.bo.UserPeriodStatusQueryBo;
import com.zhongzheng.modules.grade.bo.UserPeriodStatusEditBo;
import com.zhongzheng.modules.grade.domain.UserPeriodStatus;
import com.zhongzheng.modules.grade.mapper.UserPeriodStatusMapper;
import com.zhongzheng.modules.grade.vo.UserPeriodStatusVo;
import com.zhongzheng.modules.grade.service.IUserPeriodStatusService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-22
 */
@Service
public class UserPeriodStatusServiceImpl extends ServiceImpl<UserPeriodStatusMapper, UserPeriodStatus> implements IUserPeriodStatusService {

    @Override
    public UserPeriodStatusVo queryById(Long id){
        UserPeriodStatus db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, UserPeriodStatusVo.class);
    }

    @Override
    public List<UserPeriodStatusVo> queryList(UserPeriodStatusQueryBo bo) {
        LambdaQueryWrapper<UserPeriodStatus> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getStatus() != null, UserPeriodStatus::getStatus, bo.getStatus());
        lqw.eq(bo.getRecordStartTime() != null, UserPeriodStatus::getRecordStartTime, bo.getRecordStartTime());
        lqw.eq(bo.getRecordEndTime() != null, UserPeriodStatus::getRecordEndTime, bo.getRecordEndTime());
        lqw.eq(bo.getPeriodId() != null, UserPeriodStatus::getPeriodId, bo.getPeriodId());
        lqw.eq(bo.getPeriodStatus() != null, UserPeriodStatus::getPeriodStatus, bo.getPeriodStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserPeriodStatusVo> entity2Vo(Collection<UserPeriodStatus> collection) {
        List<UserPeriodStatusVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserPeriodStatusVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserPeriodStatus> page = (Page<UserPeriodStatus>)collection;
            Page<UserPeriodStatusVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserPeriodStatusAddBo bo) {
        UserPeriodStatus add = BeanUtil.toBean(bo, UserPeriodStatus.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserPeriodStatusEditBo bo) {
        UserPeriodStatus update = BeanUtil.toBean(bo, UserPeriodStatus.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserPeriodStatus entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<UserPeriodStatusVo> selectPeriodStatus(UserPeriodQueryBo bo) {
        return baseMapper.selectPeriodStatus(bo);
    }
}
